code:
	org 0100h

	mov al, 13h                 	;MCGA mode (320x200x256).
	int 10h                    	;Video interrupt request.

	push word 0xa000	;3b	;Video memory
	pop es			;1b

ROT	xor di, di
	inc word [@Buffer]		;
	inc word [@Buffer+4]		; update angles
	inc word [@Buffer+8]		;
;	inc word [@Buffer+12]		;

	mov cx, 3

ROTT	fild word [di+@Buffer]		;load attr angle
	fidiv word [@Buffer+2]		;scale 0 - rad - 6.3
	fsincos				; angle sin - st1 | cos - st0

	fimul word [@Buffer+6]		;scale_x * radius
	fistp word [di+@Buffer+14]		;attr_x = radius * cos (angle)
	fimul word [@Buffer+10]		;scale_y * radius
	fistp word [di+@Buffer+16]		;attr_y = radius * sin (angle)

	add di, 4			;offset to next pair of co-ords
	loop ROTT

	mov ch, 0xFA
;	xor ax, ax
	rep stosb			;clear everything else

	mov dh, 0x60		;3b	; redraw timer

DRAW	push di

	imul di, cx, 320	;7b	; di = x + (y * 320)
	add di, bx		;2b	;

;	mov [es:di], al		;3b	; faster than stosb

	stosb			;1b	; same as mov [es:di], al | inc di

	pop di

;RAND	in ax, 40h		;2b	; PIT Timer		[slow]

;RAND2	rdtsc			;2b	; CPU Timestamp		[fast ]

RAND3	add ax, di		;2b
	rol ax, 2		;5b	; Psudo-random		[fast (big :( ) compatable]
	add di, ax		;2b

	and di, 12		;2b	;[mask 00001100]

	mov bp, word [di+@Buffer+14]	;6b	; Load Attractor [requires 2^n]
	mov si, word [di+@Buffer+16]	;6b
	
	add bp, 160
	add si, 150

ATTR	sub bp, bx		;2b	; (DI - x)
	sar bp, 1		;4b	; ((DI - x) / 2)
	add bx, bp		;2b	; x + ((DI - x) / 2)

	sub si, cx		;2b	; (DX - y)
	sar si, 1		;4b	; ((DX - y) / 2)
	add cx, si		;2b	; y + ((DX - y) / 2)

	dec dx			;1b
	jne DRAW 

DRAWEND	in al, 60h			;Read value from port 60h (keyboard)
	dec al				;ESC key (scancode 1) 	[dec ax saves a byte but]
	jnz ROT				;Zero, END		[doesnt work outside windows]

END	ret                        	;DIE

data:
@Buffer	dw 0,20,41,99,82,45,0, 0,0, 0,199, 319,0, 0,-150